#feature-id    Multichannel Synthesis > DoubleDeadLine   // ### 1.8.0 RC2
#feature-info  "<p>This script allows you delete double continus dead line </p>"
#feature-icon  aip.xpm


#include <pjsr/Sizer.jsh>
#include <pjsr/FrameStyle.jsh>
#include <pjsr/TextAlign.jsh>
#include <pjsr/StdButton.jsh>
#include <pjsr/StdIcon.jsh>
#include <pjsr/UndoFlag.jsh>
#include <pjsr/ColorSpace.jsh>
#include <pjsr/UndoFlag.jsh>
#include <pjsr/DataType.jsh>

console.hide();

var window = ImageWindow.activeWindow;

function FLUserData() {
    this.position      = 0;
    this.columns       = new Array;
    this.nbrcolumns   = new Array;
}
var userData = new FLUserData;

function createDataStructure()
{
   this.inputFiles = new Array;
   this.outputDirectory = "";
}
var globalData = new createDataStructure;



function FixLinesDialog()
{
    this.__base__ = Dialog;
    this.__base__();

    //
    var emWidth = this.font.width( 'M' );
    var labelWidth1 = this.font.width( "Maximum planet radius (px):" );
    var spinWidth1 = 8*emWidth;
    //

    this.helpLabel = new Label( this );
    this.helpLabel.frameStyle = FrameStyle_Box;
    this.helpLabel.margin = 4;
    this.helpLabel.wordWrapping = true;
    this.helpLabel.useRichText = true;
    this.helpLabel.text = "<b>DoubleDeadLine Script</b> - Script to correct simple and double columns continus<br/>" +
   "<br/>" +
   "Script created by Laurent BOURGON  www.felopaul.com " + "<br/>";
    //

    this.colRowTreeBox = new TreeBox( this );
    this.colRowTreeBox.multipleSelection = true;
    this.colRowTreeBox.rootDecoration = false;
    this.colRowTreeBox.alternateRowColor = true;
    this.colRowTreeBox.setMinSize( 500, 200 );
    this.colRowTreeBox.numberOfColumns = 3;
    this.colRowTreeBox.headerVisible = false;
    //

    this.size_Label = new Label( this );
    this.size_Label.text = "Column position (px):";
    this.size_Label.textAlignment = TextAlign_Right|TextAlign_VertCenter;
    this.size_Label.minWidth = labelWidth1;

    this.size_SpinBox = new SpinBox( this );
    this.size_SpinBox.minValue = 0;
    this.size_SpinBox.maxValue = 10000;
    this.size_SpinBox.value = 0 ;
    this.size_SpinBox.setFixedWidth( spinWidth1 );
    this.size_SpinBox.toolTip = "Column position";

    this.size_SpinBox.onValueUpdated = function( value )
    {
        userData.position = value;
    };

    this.size_Sizer = new HorizontalSizer;
    this.size_Sizer.spacing = 4;
    this.size_Sizer.add( this.size_Label );
    this.size_Sizer.add( this.size_SpinBox );
    this.size_Sizer.addStretch();
    //

    this.addButton = new PushButton( this );
    this.addButton.text = " Add Simple";
    this.addButton.onClick = function() {
       this.dialog.colRowTreeBox.canUpdate = false;
        var isDone = false;
        for(var i=0;i<userData.columns.length;++i)
             if(userData.position==userData.columns[i]) isDone = true;
        if(!isDone) {
            var node = new TreeBoxNode(this.dialog.colRowTreeBox);
            node.setText(0,"column");
            node.setText(1,format("%d",userData.position));
            node.setText(2,format("simple"));
            userData.columns.push(userData.position);
            userData.nbrcolumns.push(1);
        }

       this.dialog.colRowTreeBox.canUpdate = true;
    };

    this.adddButton = new PushButton( this );
    this.adddButton.text = " Add Double";
    this.adddButton.onClick = function() {
       this.dialog.colRowTreeBox.canUpdate = false;
        var isDone = false;
        for(var i=0;i<userData.columns.length;++i)
             if(userData.position==userData.columns[i]) isDone = true;
        if(!isDone) {
            var node = new TreeBoxNode(this.dialog.colRowTreeBox);
            node.setText(0,"column");
            node.setText(1,format("%d",userData.position));
            node.setText(2,format("double"));
            userData.columns.push(userData.position);
            userData.nbrcolumns.push(2);
        }

       this.dialog.colRowTreeBox.canUpdate = true;
    };

    this.removeButton = new PushButton( this );
    this.removeButton.text = " Remove ";
    this.removeButton.onClick = function()
    {
      for ( var i = this.dialog.colRowTreeBox.numberOfChildren; --i >= 0; )
         {
            userData.columns.length = 0;
            userData.doColumns = false;
            for (var ii = 0; ii < this.dialog.colRowTreeBox.numberOfChildren; ++ii )
                if ( !this.dialog.colRowTreeBox.child( ii ).selected ) {
                    userData.columns.push(this.dialog.colRowTreeBox.child(ii).text(1));
                    userData.doColumns=true;
                }
            userData.columns[i]=0;
            this.dialog.colRowTreeBox.remove(i);
            break;
         }
    };

    this.save_Button = new PushButton( this );
    this.save_Button.text = " Save ";
    this.save_Button.onClick = function()
    {
        var saveFile = new SaveFileDialog;
        if(saveFile.execute()) {
            var fileName = saveFile.fileName;
            var f = new File;
            f.createForWriting(fileName);
            f.write(userData.columns.length,DataType_UInt16);
			for (var i = 0;i<userData.columns.length; i++)
			{
		     	f.write(userData.columns[i],DataType_Int32);
		        f.write(userData.nbrcolumns[i],DataType_Int32);				
			}
            f.close();
        }
    };
    

    this.load_Button = new PushButton( this );
    this.load_Button.text = " Load ";
    this.load_Button.onClick = function()
    {
        var loadFile = new OpenFileDialog;
        if(loadFile.execute()) {
            var fileName = loadFile.fileName;
            var f = new File;

            f.openForReading(fileName);

            for (var i = this.dialog.colRowTreeBox.numberOfChildren; i >= 0; --i) this.dialog.colRowTreeBox.remove(i);

            userData.columns.length = 0;
            userData.doColumns = false;

            var size = f.read(DataType_UInt16,1);
            if(size!=0)
            {				
                this.dialog.colRowTreeBox.canUpdate = false;
                for (var i = 0;i<size; i++)
                {
					var co,nco;
					co = f.read(DataType_Int32);
	                nco = f.read(DataType_Int32);

                    if(co!=0)
                    {
                       var node = new TreeBoxNode(this.dialog.colRowTreeBox);
                       node.setText(0,"column");
                       node.setText(1,format("%d",co));
                       if(nco==1) node.setText(2,format("simple"));
                       else node.setText(2,format("double"));
					   
					   userData.columns.push(co);
			           userData.nbrcolumns.push(nco);
                    }
                }
                this.dialog.colRowTreeBox.canUpdate = true;
            }
            f.close();
        }
    };

   this.files_TreeBox = new TreeBox( this );
   this.files_TreeBox.multipleSelection = true;
   this.files_TreeBox.rootDecoration = false;
   this.files_TreeBox.alternateRowColor = true;
   this.files_TreeBox.setMinSize( 600, 200 );
   this.files_TreeBox.numberOfColumns = 1;
   this.files_TreeBox.headerVisible = false;

   for ( var i = 0; i < globalData.inputFiles.length; ++i )
   {
      var node = new TreeBoxNode( this.files_TreeBox );
      node.setText( 0, globalData.inputFiles[i] );
   }

   this.filesAdd_Button = new PushButton( this );
   this.filesAdd_Button.text = " Add ";
   this.filesAdd_Button.toolTip = "<p>Add image files to the input images list</p>";
   this.filesAdd_Button.onClick = function()
   {
      var ofd = new OpenFileDialog;
      ofd.multipleSelections = true; // multiple files may be added at one time
      ofd.caption = "Select Images"; // this is the caption displayed with the OpenFileDialog window

      ofd.loadImageFilters();

      if ( ofd.execute() )
      {
         this.dialog.files_TreeBox.canUpdate = false;
         for ( var i = 0; i < ofd.fileNames.length; ++i )
         {
            var node = new TreeBoxNode( this.dialog.files_TreeBox );
            node.setText( 0, ofd.fileNames[i] );
            globalData.inputFiles.push( ofd.fileNames[i] );
         }
         this.dialog.files_TreeBox.canUpdate = true;
      }
   }

   this.filesClear_Button = new PushButton( this );
   this.filesClear_Button.text = " Clear ";
   this.filesClear_Button.toolTip = "<p>Clear the list of input images</p>";

   this.filesClear_Button.onClick = function()
   {
      this.dialog.files_TreeBox.clear();
      globalData.inputFiles.length = 0;
   }

   this.filesButtons_Sizer = new HorizontalSizer;
   this.filesButtons_Sizer.spacing = 4;
   this.filesButtons_Sizer.addStretch();
   this.filesButtons_Sizer.add( this.filesAdd_Button );
   this.filesButtons_Sizer.add( this.filesClear_Button );
   this.filesButtons_Sizer.addStretch();

   this.files_GroupBox = new GroupBox( this );
   this.files_GroupBox.title = "Input Images";
   this.files_GroupBox.sizer = new VerticalSizer;
   this.files_GroupBox.sizer.margin = 4;
   this.files_GroupBox.sizer.spacing = 4;
   this.files_GroupBox.sizer.add( this.files_TreeBox, 100 );
   this.files_GroupBox.sizer.add( this.filesButtons_Sizer );

   this.outputDir_Edit = new Edit( this );
   this.outputDir_Edit.readOnly = true;
   this.outputDir_Edit.text = globalData.outputDirectory;
   this.outputDir_Edit.toolTip =
      "<p>If specified, all converted images will be written to the output directory</p>" +
      "<p>If not specified, converted images will be written to the same directories " +
      "as their corresponding input images</p>";
   this.outputDirSelect_Button = new PushButton( this );
   this.outputDirSelect_Button.text = "Select";
   this.outputDirSelect_Button.toolTip = "<p>Select the output directory</p>";

   this.outputDirSelect_Button.onClick = function()
   {
      var gdd = new GetDirectoryDialog;
      gdd.initialPath = globalData.outputDirectory;
      gdd.caption = "Select Output Directory";

      if ( gdd.execute() )
      {
         globalData.outputDirectory = gdd.directory;
         this.dialog.outputDir_Edit.text = globalData.outputDirectory;
      }
   };

    this.addRemButtonsSizer3 = new HorizontalSizer;
    this.addRemButtonsSizer3.spacing = 10;
    this.addRemButtonsSizer3.addStretch();
    this.addRemButtonsSizer3.add( this.addButton,100 );
    this.addRemButtonsSizer3.add( this.adddButton,100 );
    this.addRemButtonsSizer3.add( this.removeButton,100 );
    this.addRemButtonsSizer3.addStretch();

    this.addRemButtonsSizer2 = new HorizontalSizer;
    this.addRemButtonsSizer2.spacing = 10;
    this.addRemButtonsSizer2.add( this.load_Button,70 );
    this.addRemButtonsSizer2.add( this.save_Button,70 );
    this.addRemButtonsSizer2.addStretch();

    this.colRowGroupBox = new GroupBox( this );
    this.colRowGroupBox.title = "Defects to correct:";
    this.colRowGroupBox.sizer = new VerticalSizer;
    this.colRowGroupBox.sizer.margin = 4;
    this.colRowGroupBox.sizer.spacing = 10;
    this.colRowGroupBox.sizer.add( this.colRowTreeBox, 100 );
    this.colRowGroupBox.sizer.add( this.size_Sizer );
    //this.colRowGroupBox.sizer.add( this.addRemButtonsSizer );
    this.colRowGroupBox.sizer.add( this.addRemButtonsSizer3 );
    this.colRowGroupBox.sizer.add( this.addRemButtonsSizer2 );

    this.outputDir_GroupBox = new GroupBox( this );
    this.outputDir_GroupBox.title = "Output Directory";
    this.outputDir_GroupBox.sizer = new HorizontalSizer;
    this.outputDir_GroupBox.sizer.margin = 4;
    this.outputDir_GroupBox.sizer.spacing = 4;
    this.outputDir_GroupBox.sizer.add( this.outputDir_Edit, 100 );
    this.outputDir_GroupBox.sizer.add( this.outputDirSelect_Button );

    this.ok_Button = new PushButton( this );
    this.ok_Button.text = " Execute ";
    this.ok_Button.onClick = function()
    {
      this.dialog.ok();
    }
    this.exit_Button = new PushButton( this );
    this.exit_Button.text = " Exit ";
    this.exit_Button.onClick = function()
    {
      this.dialog.cancel();
    }

    this.buttons_Sizer = new HorizontalSizer;
    this.buttons_Sizer.spacing = 4;
    this.buttons_Sizer.add( this.ok_Button );
    this.buttons_Sizer.addStretch();
    this.buttons_Sizer.add( this.exit_Button );

    this.sizer = new VerticalSizer;
    this.sizer.margin = 6;
    this.sizer.spacing = 6;
    this.sizer.add( this.helpLabel );
    this.sizer.addSpacing( 4 );
    this.sizer.add( this.colRowGroupBox );
    this.sizer.add( this.files_GroupBox );
    this.sizer.add( this.outputDir_GroupBox);
    this.sizer.add( this.buttons_Sizer );

    this.windowTitle = "DoubleDeadLine Script v1.00.06 (03-12-15)";
    this.adjustToContents();
    this.setFixedSize();
}

function FixColumn( image, col, channel)
{
    var val1;

    image.selectedChannel = channel;
    for ( var y = 1; y < (image.height-1); ++y )
    {
        val1 = (image.sample( col-1, y, channel ) + image.sample( col+1, y , channel ) + (image.sample( col-1, y-1, channel)/2) + (image.sample( col-1, y+1 , channel)/2) + (image.sample( col+1, y-1, channel)/2) + (image.sample( col+1, y+1 , channel)/2))/4;
        val1 += image.sample( col, y, channel ) - image.sample( col, y+1, channel )

        image.setSample( val1, col, y , channel );
    }
}


function FixDBColumn( image, col, channel)
{
   var val1,val2,val3,val4;
   var moy1,moy2,n;

   image.selectedChannel = channel;

   for ( var y = 1; y < (image.height-1); ++y )
   {
      val1 = (image.sample( col-1, y, channel ) + (image.sample( col-1, y+1 , channel )/2) + (image.sample( col-1, y-1 , channel )/2 ) ) / 2;
      val2 = (image.sample( col+2, y, channel ) + (image.sample( col+2, y+1 , channel )/2) + (image.sample( col+2, y-1 , channel )/2 ) ) / 2;
      val4 = (val2 + (val1/2)) / 1.5 + image.sample( col+1, y, channel ) - image.sample( col+1, y+1, channel ) ;
      image.setSample(val4 , col+1, y , channel );
      val3 = (val1 + (val2/2)) / 1.5 + image.sample( col, y, channel ) - image.sample( col, y+1, channel ) ;
      image.setSample(val3 , col, y , channel );

   };
}

function fixDBLinesEngine()
{
   console.show();

   console.writeln ("");
   console.writeln(" Start Script");
   console.writeln ("");

   var numFiles = globalData.inputFiles.length;

   console.writeln( numFiles + " File to process");
   console.writeln ("");

   if ( numFiles != 0 )
   {
      for ( var ii = 0; ii < numFiles; ++ii )
      {
         var sourceName = globalData.inputFiles[ii];

         console.writeln ("");
         console.writeln(" Open file " + sourceName);

         var fileDir = (globalData.outputDirectory.length != 0) ?  globalData.outputDirectory : File.extractDrive( sourceName ) + File.extractDirectory( sourceName );

         if ( fileDir.length != 0 && fileDir.charAt( fileDir.length-1 ) != '/' )
            fileDir += '/';
         var fileName = File.extractName( sourceName );
         var outputName = fileDir + fileName + "_cs" + ".xisf";
         var newViewName = fileName + "_cs";

         var inputImageWindow = ImageWindow.open(sourceName);

         var resultView = inputImageWindow[0].mainView;
         var sourceImage = inputImageWindow[0].mainView.image;

         with (resultView)
         {
            beginProcess();

            var isGray = image.colorSpace==ColorSpace_Gray;

            for(var i=0;i<userData.columns.length;++i)
            {
               if(userData.nbrcolumns[i]==2)
               {
                  console.writeln(" Delete double colums " + userData.columns[i]);
                  FixDBColumn(image, userData.columns[i], 0);
                  if(isGray==0) FixDBColumn(image,userData.columns[i], 1);
                  if(isGray==0) FixDBColumn(image,userData.columns[i], 2);
               }
               else
               {
                  console.writeln(" Delete simple colums " + userData.columns[i]);
                  FixColumn(image, userData.columns[i], 0);
                  if(isGray==0) FixColumn(image, userData.columns[i], 1);
                  if(isGray==0) FixColumn(image, userData.columns[i], 2);
               }
            }

            console.writeln("");

            endProcess();
         }


         resultView.window.saveAs( outputName, false, false, false, false );
         resultView.window.forceClose();
      }
   }

   console.hide();
}



FixLinesDialog.prototype = new Dialog;
function main()
{
    var dialog = new FixLinesDialog();
    //dialog.view = view;

    if(dialog.execute())  fixDBLinesEngine();
}

main();
