#feature-id    Multichannel Synthesis > LRVB-AIP // ### 1.8.0 RC2
#feature-info  "<p>This script allows you to mix L with a RVB  with AIP Method</p>"
#feature-icon  aip.xpm // ### 1.8.0 RC2

#include "fra.jsh"

#include <pjsr/Sizer.jsh>
#include <pjsr/Interpolation.jsh>
#include <pjsr/SampleType.jsh>
#include <pjsr/FrameStyle.jsh>
#include <pjsr/TextAlign.jsh>
#include <pjsr/StdButton.jsh>
#include <pjsr/StdIcon.jsh>
#include <pjsr/ColorComboBox.jsh>
#include <pjsr/UndoFlag.jsh>
#include <pjsr/NumericControl.jsh>

#define DEFAULT_TB_MARGIN 10
#define DEFAULT_RL_MARGIN 10
#define DEFAULT_BORDER_WIDTH 1
#define VERSION_LRGB "1.0"
#define TITLE  "LRVB-AIP"

var Flout_L=1.0;

function Inset()
{
   this.executeMainFunction = function()
   {
      if(this.RVB_Image == this.HAL_Image)
      {
         var msg = new MessageBox( TEXT19, "Image Selection Warning", StdIcon_Warning, StdButton_Ok );
         msg.execute();
         return false;
      }
      else
      {
         makeInset(this.RVB_Image, this.HAL_Image);
         return true;
      }
   };
};

function makeInset(RVB_Image, HAL_Image)
{
    console.show();

    var w = ImageWindow.windowById( RVB_Image );
    var RGBView = w.currentView;

    var Preview= new ImageWindow(RGBView.image.width,
                                 RGBView.image.height,
                                 3,
                                 32,
                                 true,
                                 true,
                                 "LRVB");

   Preview.mainView.beginProcess(UndoFlag_NoSwapFile);
   Preview.mainView.image.fill( 0 );
   Preview.mainView.endProcess();
   Preview.zoomFactor=12;
   Preview.fitWindow();
   Preview.zoomToOptimalFit();
   Preview.show();

   Preview.mainView.beginProcess(UndoFlag_NoSwapFile);
	 Preview.mainView.image.assign(RGBView.image);
   Preview.mainView.endProcess();


    var target_window = ImageWindow.windowById( "LRVB" );
    var target_view   = target_window.currentView;
    var target_img    = target_window.currentView.image;

    //console.writeln( "Start Mix HA with RGB  33%" );

     var P1 = new LRGBCombination;
    P1.channels = [ // enabled, id, k
                   [false, "", 1.00000],
                   [false, "", 1.00000],
                   [false, "", 1.00000],
                   [true, HAL_Image, 0.33000]    //  33%
                ];
    P1.mL = 0.500;
    P1.mc = 0.500;
    P1.clipHighlights = true;
    P1.noiseReduction = false;
    P1.layersRemoved = 4;
    P1.layersProtected = 2;

    P1.executeOn( target_view, false );
    target_img.resetSelections();

    var P2 = new ACDNR;
    P2.applyToLightness = true;
   P2.applyToChrominance = true;
   P2.useMaskL = false;
   P2.useMaskC = false;
   P2.sigmaL = 1.5;
   P2.sigmaC = 2.0;
   P2.shapeL = 0.50;
   P2.shapeC = 0.50;
   P2.amountL = 0.20;
   P2.amountC = 1.00;
   P2.iterationsL = Flout_L;
   P2.iterationsC = Flout_L;
   P2.prefilterMethodL = ACDNR.prototype.None;
   P2.prefilterMethodC = ACDNR.prototype.None;
   P2.protectionMethodL = ACDNR.prototype.WeightedAverage3x3;
   P2.protectionMethodC = ACDNR.prototype.UnweightedAverage3x3;
   P2.minStructSizeL = 5;
   P2.minStructSizeC = 5;
   P2.protectDarkSidesL = false;
   P2.protectDarkSidesC = true;
   P2.darkSidesThresholdL = 0.015;
   P2.darkSidesThresholdC = 0.030;
   P2.darkSidesOverdriveL = 0.00;
   P2.darkSidesOverdriveC = 0.00;
   P2.protectBrightSidesL = false;
   P2.protectBrightSidesC = true;
   P2.brightSidesThresholdL = 0.015;
   P2.brightSidesThresholdC = 0.030;
   P2.brightSidesOverdriveL = 0.00;
   P2.brightSidesOverdriveC = 0.00;
   P2.starProtectionL = true;
   P2.starProtectionC = true;
   P2.starThresholdL = 0.030;
   P2.starThresholdC = 0.030;
   P2.previewMask = false;
   P2.maskRemovedWaveletLayers = 1;
   P2.maskShadowsClipping = 0.00000;
   P2.maskHighlightsClipping = 1.00000;
   P2.maskMTF = 0.50000;

    P2.executeOn( target_view, false );
    target_img.resetSelections();

    var P3 = new LRGBCombination;
    P3.channels = [ // enabled, id, k
       [false, "", 1.00000],
       [false, "", 1.00000],
       [false, "", 1.00000],
       [true, HAL_Image, 0.66000]         //////// 66%
    ];
    P3.mL = 0.500;
    P3.mc = 0.500;
    P3.clipHighlights = true;
    P3.noiseReduction = false;
    P3.layersRemoved = 4;
    P3.layersProtected = 2;

    P3.executeOn( target_view, false );
    target_img.resetSelections();

    var P4 = new ACDNR;
      P4.applyToLightness = true;
      P4.applyToChrominance = true;
      P4.useMaskL = false;
      P4.useMaskC = false;
      P4.sigmaL = 1.5;
      P4.sigmaC = 2.0;
      P4.shapeL = 0.50;
      P4.shapeC = 0.50;
      P4.amountL = 0.20;
      P4.amountC = 1.00;
      P4.iterationsL = Flout_L;
      P4.iterationsC = Flout_L;
      P4.prefilterMethodL = ACDNR.prototype.None;
      P4.prefilterMethodC = ACDNR.prototype.None;
      P4.protectionMethodL = ACDNR.prototype.WeightedAverage3x3;
      P4.protectionMethodC = ACDNR.prototype.UnweightedAverage3x3;
      P4.minStructSizeL = 5;
      P4.minStructSizeC = 5;
      P4.protectDarkSidesL = false;
      P4.protectDarkSidesC = true;
      P4.darkSidesThresholdL = 0.015;
      P4.darkSidesThresholdC = 0.030;
      P4.darkSidesOverdriveL = 0.00;
      P4.darkSidesOverdriveC = 0.00;
      P4.protectBrightSidesL = false;
      P4.protectBrightSidesC = true;
      P4.brightSidesThresholdL = 0.015;
      P4.brightSidesThresholdC = 0.030;
      P4.brightSidesOverdriveL = 0.00;
      P4.brightSidesOverdriveC = 0.00;
      P4.starProtectionL = true;
      P4.starProtectionC = true;
      P4.starThresholdL = 0.030;
      P4.starThresholdC = 0.030;
      P4.previewMask = false;
      P4.maskRemovedWaveletLayers = 1;
      P4.maskShadowsClipping = 0.00000;
      P4.maskHighlightsClipping = 1.00000;
      P4.maskMTF = 0.50000;

    P4.executeOn( target_view, false );
    target_img.resetSelections();

    var P5 = new LRGBCombination;
    P5.channels = [ // enabled, id, k
       [false, "", 1.00000],
       [false, "", 1.00000],
       [false, "", 1.00000],
       [true, HAL_Image, 1.00000]           //// 100%
    ];
    P5.mL = lightness;
    P5.mc = saturation;
    P5.clipHighlights = true;
    P5.noiseReduction = noiser;
    P5.layersRemoved = smoothed;
    P5.layersProtected = protectedw;

    P5.executeOn( target_view, false );
    target_img.resetSelections();

    console.hide();
}

var engine = new Inset;

function ii_dialog() {

   this.__base__ = Dialog;
   this.__base__();

   this.helpLabel = new Label (this);
   this.helpLabel.frameStyle = FrameStyle_Box;
   this.helpLabel.margin = 4;
   this.helpLabel.wordWrapping = true;
   this.helpLabel.useRichText = true;
   this.helpLabel.text = "<b>" + TITLE + " v" + VERSION_LRGB + "</b> &mdash; "+TEXT22+" L.Bourgon ";
   this.helpLabel.setMinWidth( 490 );


   // Target Image Selection
   this.TargetImage_ComboBox = new ComboBox( this );
   this.TargetImage_ComboBox.setMinWidth( 380 );
   var workspace_windows = ImageWindow.windows;
   with( this.TargetImage_ComboBox )
   {
      for ( var j = 0; j < workspace_windows.length; ++j )
      {
         addItem( workspace_windows[j].mainView.id );
         onItemSelected = function(j) { engine.HAL_Image = workspace_windows[j].mainView.id; }
      } // for
      engine.HAL_Image = workspace_windows[0].mainView.id;
   } // with
   // ----

   // Inset Image Selection
   this.InsetImage_ComboBox = new ComboBox( this );
   this.InsetImage_ComboBox.setMinWidth( 380 );
   var workspace_windows = ImageWindow.windows;
   with( this.InsetImage_ComboBox )
   {
      for ( var j = 0; j < workspace_windows.length; ++j )
      {
         addItem( workspace_windows[j].mainView.id );
         onItemSelected = function(j) { engine.RVB_Image = workspace_windows[j].mainView.id; }
      } // for
      engine.RVB_Image = workspace_windows[0].mainView.id;
   } // with
   // ----

   // Image Selection Labels
   // Target
   this.TargetImage_Label = new Label (this);
   this.TargetImage_Label.textAlignment = TextAlign_Left|TextAlign_VertCenter;
   this.TargetImage_Label.margin = 6;
   this.TargetImage_Label.text = TEXT20;
   // Inset
   this.InsetImage_Label = new Label (this);
   this.InsetImage_Label.textAlignment = TextAlign_Left|TextAlign_VertCenter;
   this.InsetImage_Label.margin = 6;
   this.InsetImage_Label.text = TEXT21;
   // ----
   this.TargetImage_Sizer = new HorizontalSizer;
   with ( this.TargetImage_Sizer )
   {
      add( this.TargetImage_Label );
      addStretch();
      add( this.TargetImage_ComboBox, 100 );
      addSpacing( 6 );
   }

   this.InsetImage_Sizer = new HorizontalSizer;
   with ( this.InsetImage_Sizer )
   {
      add( this.InsetImage_Label );
      addStretch();
      add( this.InsetImage_ComboBox, 100 );
      addSpacing( 6 );
   }

   this.FloutControl = new NumericControl( this );
   with ( this.FloutControl )
   {
		setRange( 1, 5 );
      label.text = TEXT12;
		label.minWidth = 50;
		slider.setRange( 1, 5 );
		slider.minWidth = 100;
		setPrecision (0);
		setValue( Flout_L);
		onValueUpdated = function( value ) {
			Flout_L = value;
		};
	 }

   this.buttons_SizerF = new HorizontalSizer;
   this.buttons_SizerF.spacing = 6;
   this.buttons_SizerF.addStretch();
   this.buttons_SizerF.add (this.FloutControl);
   this.buttons_SizerF.addStretch();

   this.lightnessControl = new NumericControl( this );
   with ( this.lightnessControl )
   {
		setRange( 0.0, 1.0 );
      label.text = "Transfer Fonctions - Lightness: ";
		slider.setRange( 0, 200);
		slider.minWidth = 0;
		setPrecision (3);
		setValue( lightness);
		onValueUpdated = function( value ) {
			lightness = value;
		};
	}

   this.saturationControl = new NumericControl( this );
   with ( this.saturationControl)
   {
		setRange( 0.0, 1.0 );
      label.text = "Saturation: ";
		slider.setRange( 0, 200);
		slider.minWidth = 0;
		setPrecision (3);
		setValue( saturation);
		onValueUpdated = function( value ) {
			saturation = value;
		};
	}

   this.CNR_CheckBox = new CheckBox( this );
	this.CNR_CheckBox.text = TEXT11; // "Chroma Noise Reduction"
	this.CNR_CheckBox.checked = noiser;
	this.CNR_CheckBox.onCheck = function( checked ) {
   noiser = checked;
   };

   this.smoothed_Label = new Label (this);
   this.smoothed_Label.textAlignment = TextAlign_Left|TextAlign_VertCenter;
   this.smoothed_Label.margin = 6;
   this.smoothed_Label.text = " SmotherdWL : ";

   this.smoothed_SpinBox = new SpinBox( this );
   this.smoothed_SpinBox.minValue = 1;
   this.smoothed_SpinBox.maxValue = 6;
   this.smoothed_SpinBox.value = smoothed;
   this.smoothed_SpinBox.onValueUpdated = function( value )
   {
      smoothed = value;
   };

   this.protected_Label = new Label (this);
   this.protected_Label.textAlignment = TextAlign_Left|TextAlign_VertCenter;
   this.protected_Label.margin = 6;
   this.protected_Label.text = " ProtectedWL : ";
   this.protected_SpinBox = new SpinBox( this );
   this.protected_SpinBox.minValue = 0;
   this.protected_SpinBox.maxValue = 5;
   this.protected_SpinBox.value = protectedw;
   this.protected_SpinBox.onValueUpdated = function( value )
   {
      protectedw = value;
   };

   this.number3fLayers_Sizer = new HorizontalSizer;
	this.number3fLayers_Sizer.setAlignment = Align_Center;
   this.number3fLayers_Sizer.addStretch();
	this.number3fLayers_Sizer.add( this.lightnessControl );
   this.number3fLayers_Sizer.addSpacing( 10 );
   this.number3fLayers_Sizer.add( this.saturationControl );
   this.number3fLayers_Sizer.addStretch();

   this.number4fLayers_Sizer = new HorizontalSizer;
   this.number4fLayers_Sizer.setAlignment = Align_Center;
   this.number4fLayers_Sizer.addStretch();
   this.number4fLayers_Sizer.add( this.CNR_CheckBox );
   this.number4fLayers_Sizer.add( this.smoothed_Label );
   this.number4fLayers_Sizer.add( this.smoothed_SpinBox );
   this.number4fLayers_Sizer.add( this.protected_Label );
   this.number4fLayers_Sizer.add( this.protected_SpinBox );
   this.number4fLayers_Sizer.addStretch();

   this.Images_GroupBox = new GroupBox (this);
   this.Images_GroupBox.title = TEXT2;
   this.Images_GroupBox.sizer = new VerticalSizer;
   this.Images_GroupBox.sizer.addSpacing( 6 );
   this.Images_GroupBox.sizer.add ( this.TargetImage_Sizer );
   this.Images_GroupBox.sizer.addSpacing( 2 );
   this.Images_GroupBox.sizer.add ( this.InsetImage_Sizer );
   this.Images_GroupBox.sizer.addSpacing( 6 );

   this.Images_GroupBox2 = new GroupBox (this);
   this.Images_GroupBox2.title = TEXT7;
   this.Images_GroupBox2.sizer = new VerticalSizer;
   this.Images_GroupBox2.sizer.addSpacing( 6 );
   this.Images_GroupBox2.sizer.add ( this.buttons_SizerF);
   this.Images_GroupBox2.sizer.addSpacing( 2 );
   this.Images_GroupBox2.sizer.add ( this.number3fLayers_Sizer );
   this.Images_GroupBox2.sizer.addSpacing( 2 );
   this.Images_GroupBox2.sizer.add ( this.number4fLayers_Sizer);
   this.Images_GroupBox2.sizer.addSpacing( 6 );


   // Buttons

   this.ok_Button = new PushButton (this);
   this.ok_Button.text = "OK";

#ifneq __PI_PLATFORM__ MACOSX
   this.ok_Button.icon = new Bitmap( ":/images/icons/ok.png" );
#endif

   this.ok_Button.onClick = function()
   {
      var result = engine.executeMainFunction();
      this.dialog.cancel();
   };

   this.cancel_Button = new PushButton (this);
   this.cancel_Button.text = "Cancel";

#ifneq __PI_PLATFORM__ MACOSX
   this.cancel_Button.icon = new Bitmap( ":/images/icons/cancel.png" );
#endif

   this.cancel_Button.onClick = function() {
      this.dialog.cancel();
   };

   this.buttons_Sizer = new HorizontalSizer;
   this.buttons_Sizer.spacing = 6;
   this.buttons_Sizer.addStretch();
   this.buttons_Sizer.add (this.ok_Button);
   this.buttons_Sizer.add (this.cancel_Button);

   this.sizer = new VerticalSizer;
   this.sizer.margin = 6;
   this.sizer.spacing = 6;
   this.sizer.add ( this.helpLabel );
   this.sizer.addSpacing (4);
   this.sizer.add( this.Images_GroupBox );
   this.sizer.addSpacing (4);
   this.sizer.add( this.Images_GroupBox2 );
   this.sizer.addSpacing (4);
   this.sizer.add ( this.buttons_Sizer );

   this.windowTitle = TITLE + " Script v" + VERSION_LRGB;
   this.adjustToContents();

}

ii_dialog.prototype = new Dialog;

// UI End

function main()
{

   console.hide();
   var window = ImageWindow.activeWindow;

   if ( window.isNull )
   {
      console.show();
      console.writeln(ERROR1);
   }
   else
   {
      var dialog = new ii_dialog();
      dialog.execute();
   }

};

var lightness = 0.5;
var saturation = 0.5;
var smoothed = 4;
var protectedw = 2;
var noiser=false;

main();
